' MAXIDASH 1b by R.A. van Engelen 2018 license: BSD-3 open source
' Requires BASEDASH.BAS in the current SD directory

  If chained Then

    i = Instr(MM.Fname$, ".")
    script$ = Left$(MM.Fname$, i - 1)

    Print @(318,240) "AUTO SAVE";

    If key <> 13 Then GoTo Action

    n = n + 1

    GoTo Move

  EndIf

  Option error continue
  Option base 0

  Mode 1
  Font 1,,0

  Dim p$(52) length 120 ' expr for 40 pins, 10 mem, 2 pwm
  Dim p(52) ' value of the 40 pins, 10 mem, 2 pwmm 1 LED
  Dim u(52) ' negative or 0 = unused, 1 = used, 2 = used and set p(n) by code
  Dim m(40) ' pin mode
  Dim m$(11) length 4 ' 9 modes for pin, 2 modes for mem

  m$(0)="----"
  m$(1)=" AIN"
  m$(2)=" DIN"
  m$(3)=" FIN"
  m$(4)=" PIN"
  m$(5)=" CIN"
  m$(8)="DOUT"
  m$(9)="OOUT"
  m$(10)="HOLD"
  m$(11)="    "

  freq = 100000 ' PWM frequency 100kHz
  functions$ = "1:ABS,1:ATN,1:COS,1:DEG,1:EXP,1:FIX,1:INT,1:INV,1:LOG,2:MAX,2:MIN,2:POW,1:RAD,1:RND,1:SGN,2:SHL,2:SHR,1:SIN,1:SQR,1:TAN,"
  script$ = "ZZZZDASH"
  p(0) = 1 ' LED on
  ed = 0 ' edit mode, 0, 1 or 2
  n = 1 ' current pin/mem cell selected

  Init

  Cls
  Print "PIN J9  MODE: VALUE       PIN D/A MODE: VALUE       MEM MODE: VALUE";
  For i = 0 To 52
    DrawCell i
  Next i
  Font 1,,1
  DrawCell n
  Font 1,,0

  Print @(318,192) "T:";
  Print @(318,216) "FPS:";
  Print @(318,240) "AUTO SAVE: " script$
  Print "= " Tab(48)
  Print "+----------------------+----------------------+----------------------+---------+"
  Print "| PIN/MEM commands:    | Program commands:    | Navigation commands: |         |"
  Print "| I     set input PIN  | S     save           | UP/DOWN              |  M   R. |"
  Print "| O     set output PIN | E     export         | TAB/LEFT/RIGHT       |  A   A. |"
  Print "| -     disable PIN    | =     assign formula | PAGEUP/PAGEDOWN      |  X   v. |"
  Print "| SPACE (un)hold value | ENTER edit formula   | HOME/END             |  I   E  |"
  Print "+----------------------+----------------------+----------------------+  D   n  |"
  Print "| Formula operators:   | Formula functions:   | Formula operands:    |  A   g  |"
  Print "| ? :     if-then-else | ABS ATN COS DEG EXP  | P0-P40 PIN           |  S   e  |"
  Print "| || &&   conditionals | FIX INT INV LOG MAX  | M0-M9  MEM           |  H   l  |"
  Print "| | ^ &   bit-wise     | MIN POW RAD RND SGN  | C4-C22 J9 connector  |      e  |"
  Print "| = != < <= > >=       | SHL SHR SIN SQR TAN  | D0-D13 and A0-A5     | 1b   n  |"
  Print "| + -   * / \ %   ~ !  |                      | HIGH/LOW/KEY/T/numbr | 2018    |"
  Print "+----------------------+----------------------+----------------------+---------+";

  Timer = 0

Refresh:

  t = Timer
  Print @(318+6*3,192) Format$(t, "%.0f");

  Update

  If u(0) > 0 Then Print @(318+6*8,156) Format$(p(0), "% -12g");: Pin(0) = p(0)
  For i = 1 To 20
    If u(i) > 0 Then
      If m(i) < 6 Then p(i) = Pin(i) Else Pin(i) = p(i)
      Print @(6*13,12*i) Format$(p(i), "% -12g");
    EndIf
    j = i + 20
    If u(j) > 0 Then
      If m(j) < 6 Then p(j) = Pin(j) Else Pin(j) = p(j)
      Print @(162+6*12,12*i) Format$(p(j), "% -12g");
    EndIf
  Next i
  For i = 41 To 50
    If u(i) > 0 Then Print @(318+6*8,12*(i-40)) Format$(p(i), "% -12g");
  Next i
  If u(51) > 0 Or u(52) > 0 Then
    If p(51) Or p(52) Then PWM freq, p(51), p(52) Else PWM stop
    Print @(318+6*8,132) Format$(p(51), "% -12g");
    Print @(318+6*8,144) Format$(p(52), "% -12g");
  EndIf

  If Not (t And 31) Then Print @(318+6*4,216) 1000\(Timer-t) " "

  key = Asc(Inkey$)

  If Not key Then GoTo Refresh

Action:

  m = n
  If ed Then
    If key = 9 Or key = 13 Or key = 27 Or key = 128 Or key = 129 Or key > 144 Then
      If ed = 1 Then
        If key = 27 Then
          Print @(0,252) "= " Left$(q$, 42) Tab(48)
          p$(n) = q$
          ed = 0
        Else
          If n > 0 And n < 41 Then
            If Not m(n) Then
              m(n) = 8
              SetPin n, m(n)
            EndIf
          EndIf
          Trim p$(n)
          in$ = p$(n)
          i = 1
          l = Len(in$)
          ex$ = ParseNumber$()
          Print @(48*6,252) Space$(32);
          If i >= l Then
            ed = 0
            u(n) = 1
            p(n) = Val(ex$)
          Else
            ex$ = ""
            er = 0
            ClearTemp
            fd = 0
            Compile
            If er = 0 And i <= l Then er$ = "operator expected": er = i
            If er Then
              Font 1,,1
              Print @(48*6,252) er$;
              Font 1,,0
              cur = er
              key = 131
            Else
              ed = 0
              u(n) = 2
              SaveCode
            EndIf
          EndIf
          If key <> 13 Then GoTo Action
          n = n + 1
        EndIf
      Else
        If key = 27 Then
          script$ = q$
          Print @(318+6*11,240) script$ Space$(8);
        Else
          SaveCode
        EndIf
        ed = 0
      EndIf
    EndIf
    If ed = 1 Then
      Print @(12,252);
      key = LineEdit(p$(n), cur, key, 120, 42)
    ElseIf ed = 2 Then
      Print @(318+6*11,240);
      key = LineEdit(script$, cur, key, 8, 8)
    EndIf
  ElseIf key = 61 Then '=
    Print @(0,252) "= " Tab(48);
    ed = 1
    q$ = p$(n)
    p$(n) = ""
    key = 134
    GoTo Action
  ElseIf key = 13 Then
    ed = 1
    q$ = p$(n)
    key = 135
    GoTo Action
  ElseIf (key Or 32) = 115 Then 's
    ed = 2
    q$ = script$
    key = 135
    GoTo Action
  ElseIf (key Or 32) = 101 Then 'e
    If MM.Errno Then
      Print @(48*6,252) "Cannot save " script$ ".DSH"
    Else
      ExportCode
    EndIf
  ElseIf key = 45 Then '-
    If n > 0 And n < 41 Then
      If u(n) > 0 Then u(n) = -u(n)
      m(n) = 0
      SetPin n, 0
    EndIf
  ElseIf (key Or 32) = 105 Then 'i
    If n > 0 And n < 11 Then
      If u(n) <= 0 Then u(n) = Max(-u(n), 1)
      m(n) = 1+(m(n)+1) Mod 2
      SetPin n, m(n)
    ElseIf n > 10 And n < 15 Then
      If u(n) <= 0 Then u(n) = Max(-u(n), 1)
      m(n) = 2+(m(n)+3) Mod 4
      SetPin n, m(n)
    ElseIf n > 14 And n < 35 Then
      If u(n) <= 0 Then u(n) = Max(-u(n), 1)
      m(n) = 2
      SetPin n, m(n)
    ElseIf n > 34 And n < 41 Then
      If u(n) <= 0 Then u(n) = Max(-u(n), 1)
      m(n) = 1
      SetPin n, m(n)
    EndIf
  ElseIf (key Or 32) = 111 Then 'o
    If n > 10 And n < 21 Then
      If u(n) <= 0 Then u(n) = Max(-u(n), 1)
      m(n) = 8+(m(n)+1) Mod 2
      SetPin n, m(n)
    ElseIf n < 41 Then
      If u(n) <= 0 Then u(n) = Max(-u(n), 1)
      m(n) = 8
      SetPin n, m(n)
    EndIf
  ElseIf key = 32 Then
    u(n) = -u(n)
    If n > 0 And n < 41 Then
      If Not m(n) And u(n) > 0 Then u(n) = -u(n)
    EndIf
  ElseIf key = 9 Then
    n = 1 + (n + 19) Mod 40
  ElseIf key = 128 Then
    n = n - 1
  ElseIf key = 129 Then
    n = n + 1
  ElseIf key = 130 Then
    n = n + 33
  ElseIf key = 131 Then
    n = n + 20
  ElseIf key = 134 Then
    n = 1
  ElseIf key = 135 Then
    n = 0
  ElseIf key = 136 Then
    n = 1 + (n - 1) \ 20 * 20
  ElseIf key = 137 Then
    n = 20 + (n - 1) \ 20 * 20
    If n > 50 Then n = 50
  ElseIf key = 145 Then 'F1
    SaveBMP "MAXIDASH.BMP"
  EndIf

Move:

  n = (n + 53) Mod 53
  If n <> m Then
    DrawCell m
    Print @(0,252) "= " Left$(p$(n), 42) Tab(48);
  EndIf
  Font 1,,1
  DrawCell n
  Font 1,,0

  GoTo Refresh

End

' DrawCell(i) shows cell i
' in arg: i
' in: p(), u(), m(), m$()
Sub DrawCell(i)
  Local j
  If i = 0 Then
    Print @(318,156) "PIN0LED:";
    If u(0) > 0 Then Print Format$(p(0), "% -12g"); Else Print Space$(12);
  ElseIf i < 21 Then
    If i < 11 Then j = 19 + 2 * i Else j = 2 * i - 18
    Print @(6,12*i) Format$(i, "%2g") " C" Format$(j, "%-3g") m$(m(i)) ":";
    If m(i) Then Print Format$(p(i), "% -12g"); Else Print Space$(12);
  ElseIf i < 35 Then
    Print @(162,12*i-240) Format$(i, "%2g") " D" Format$(i - 21, "%-3g") m$(m(i)) ":";
    If m(i) Then Print Format$(p(i), "% -12g"); Else Print Space$(12);
  ElseIf i < 41 Then
    Print @(162,12*i-240) Format$(i, "%2g") " A" Format$(i - 35, "%-3g") m$(m(i)) ":";
    If m(i) Then Print Format$(p(i), "% -12g"); Else Print Space$(12);
  ElseIf i < 51 Then
    Print @(318,12*i-480) "M" Format$(i - 41, "%g") " " m$(10+(u(i)>0)) ":";
    Print Format$(p(i), "% -12g");
  ElseIf i = 51 Then
    Print @(318,132) "PWM CH1:";
    If u(51) > 0 Then Print Format$(p(51), "% -12g"); Else Print Space$(12);
  ElseIf i = 52 Then
    Print @(318,144) "PWM CH2:";
    If u(52) > 0 Then Print Format$(p(52), "% -12g"); Else Print Space$(12);
  EndIf
End Sub

' SaveCode saves current MAXIDASH as script$ + ".BAS"
' in: p$(), p(), u(), m()
' changed: in$, i, l, ex$, er, fd
Sub SaveCode
  Local k, k$
  k$ = Dir$("BASEDASH.BAS", FILE)
  If k$ = "" Then
    Print @(48*6,252) "BASEDASH.BAS not found";
  Else
    Copy k$ To script$ + ".BAS"
    Open script$ + ".BAS" For append As #1
    If MM.Errno Then
      Print @(48*6,252) "Cannot save " script$ ".BAS"
    Else
      Font 1,,1
      Print @(318,240) "SAVING...";
      Font 1,,0
      Print #1, "SUB Init"
      For k = 0 To 52
        k$ = Str$(k)
        If p$(k) <> "" Then Print #1, "p$(" k$ ") = " Chr$(34) p$(k) Chr$(34)
        Print #1, "p(" k$ ") =" p(k) ": u(" k$ ") =" u(k);
        If k > 0 And k < 41 Then Print #1, ": m(" k$ ") =" m(k);
        If k > 0 And k < 41 Then Print #1, ": SETPIN " k$ "," m(k);
        Print #1
      Next k
      Print #1, "END SUB"
      Print #1, "SUB Update"
      For k = 0 To 52
        in$ = p$(k)
        If in$ <> "" Then
          i = 1
          l = Len(in$)
          ex$ = ""
          er = 0
          fd = 1
          ClearTemp
          Compile
          If Not er Then
            k$ = Str$(k)
            Print #1, "IF u(" k$ ") > 1 THEN p(" k$ ") = " ex$
          EndIf
        EndIf
      Next k
      Print #1, "END SUB"
      Close #1
      Print @(318,240) "AUTO SAVE";
      chained = 1
      Chain script$ + ".BAS"
    EndIf
  EndIf
End Sub

' ExportCode exports a maxidash program as script$ + ".DSH"
' in: p$(), p(), u(), m()
' changed: in$, i, l, ex$, er, fd
Sub ExportCode
  Local k, k$
  Open script$ + ".DSH" For output As #1
  If MM.Errno Then
    Print @(48*6,252) "Cannot save " script$ ".DSH"
  Else
    Font 1,,1
    Print @(318,240) "SAVING...";
    Font 1,,0
    Print #1, "' init then update pins continuously"
    Print #1, "Init"
    Print #1, "DO: Update: LOOP"
    Print #1, "END"
    Print #1, "' set pin modes and initialize p() pin/mem values"
    Print #1, "SUB Init"
    Print #1, "DIM p(52)"
    For k = 0 To 52
      Print #1, "p(" Str$(k) ") =" p(k)
    Next k
    For k = 1 To 40
      If u(k) > 0 Then Print #1, "SETPIN" k "," m(k)
    Next k
    Print #1, "END SUB"
    Print #1, "' update pins and p() values"
    Print #1, "SUB Update"
    Print #1, "LOCAL key"
    Print #1, "key = ASC(INKEY$)"
    For k = 0 To 52
      If u(k) > 1 Then
        in$ = p$(k)
        If k > 0 And k < 41 Then
          If m(k) < 6 Then in$ = ""
        EndIf
        If in$ <> "" Then
          i = 1
          l = Len(in$)
          ex$ = ""
          er = 0
          fd = 1
          ClearTemp
          Compile
          If Not er Then Print #1, "p(" Str$(k) ") = " ex$
        EndIf
      EndIf
    Next k
    For k = 1 To 40
      If u(k) > 0 Then
        k$ = Str$(k)
        If m(k) < 6 Then
          Print #1, "p(" k$ ") = PIN(" k$ ")"
        Else
          Print #1, "PIN(" k$ ") = p(" k$ ")"
        EndIf
      EndIf
    Next k
    If u(51) > 0 Or u(52) > 0 Then
      If p(51) Or p(52) Then Print #1, "PWM" freq ", p(51), p(52)"
    EndIf
    Print #1, "END SUB"
    Print #1, "FUNCTION MIN(x, y)"
    Print #1, "IF x < y THEN MIN = x ELSE MIN = y"
    Print #1, "END FUNCTION"
    Print #1, "FUNCTION MAX(x, y)"
    Print #1, "IF x > y THEN MAX = x ELSE MAX = y"
    Print #1, "END FUNCTION"
    Print #1, "FUNCTION SHL(x, n)"
    Print #1, "SHL = x * 2^n"
    Print #1, "END FUNCTION"
    Print #1, "FUNCTION SHR(x, n)"
    Print #1, "SHR = x \ 2^n"
    Print #1, "END FUNCTION"
    Print #1, "FUNCTION POW(x, y)"
    Print #1, "POW = x ^ y"
    Print #1, "END FUNCTION"
    Print #1, "FUNCTION INV(x)"
    Print #1, "INV = -1 - x"
    Print #1, "END FUNCTION"
    Close #1
    Print @(318,240) "AUTO SAVE";
  EndIf
End Sub

' LineEdit(a$, [cur [, key [, max [, win ]]]])
' Edits line a$ at cur using key (if nonzero), max len and win sizes
Function LineEdit(a$, cur, key, max, win)
  Local x, y, size, from, done
  x = MM.HPos: y = MM.VPos
  If max <= 0 Then max = 255
  If win <= 0 Then win = 255
  size = Len(a$)
  If cur < 0 Then
    cur = 0
  ElseIf cur > size Then
    cur = size
  EndIf
  done = key
  Do
    If key >= 32 And key < 127 Then
      If size < max Then
        a$ = Left$(a$, cur) + Chr$(key) + Mid$(a$, cur + 1)
        cur = cur + 1
        size = size + 1
      EndIf
    ElseIf key = 8 Then
      If cur > 0 Then
        cur = cur - 1
        a$ = Left$(a$, cur) + Mid$(a$, cur + 2)
        size = size - 1
      EndIf
    ElseIf key = 127 Then
      If cur < size Then
        a$ = Left$(a$, cur) + Mid$(a$, cur + 2)
        size = size - 1
      EndIf
    ElseIf key = 130 Then
      If cur > 0 Then cur = cur - 1
    ElseIf key = 131 Then
      If cur < size Then cur = cur + 1
    ElseIf key = 134 Then
      cur = 0
    ElseIf key = 135 Then
      cur = size
    ElseIf key > 0 Then
      ' done editing, so print a clean line
      Print @(x,y) Left$(a$, win);
      ' remove the cursor from the end of the line
      If cur = size And size < win Then Print " ";
      Exit
    EndIf
    ' cursor cannot move beyond string max length
    If cur >= max Then cur = max - 1
    ' cursor is offset from window start
    If cur >= win Then from = cur - win + 2 Else from = 1
    If cur = size Then
      ' print the line constrained to the window size
      Print @(x,y) Mid$(a$, from);
      ' put the cursor at the end
      Font 1,,1: Print " ";: Font 1,,0
      ' BACKSPACE may require removing the cursor from the end of the line
      If key = 8 Then
        If cur + 1 < win And size < win Then Print " ";
      EndIf
    Else
      ' print the line constrained to window size
      Print @(x,y) Mid$(a$, from, cur - from + 1);
      ' invert character at the cursor
      Font 1,,1: Print Mid$(a$, cur + 1, 1);: Font 1,,0
      ' print the rest of the line
      Print Mid$(a$, cur + 2, win - cur + from - 2);
      If cur < win And size < win Then Print " ";
    EndIf
    ' if this is a non-blocking call then exit
    If done > 0 Then Exit
    ' wait on key press
    Do: key = Asc(Inkey$): Loop Until key
    done = -done
  Loop
  ' move cursor back to the start of the line before returning
  Print @(x,y);
  LineEdit = key
End Function

' Compile parses expression mid$(in$, i) into ex$ and written to #fd, sets er$ and er on error
' in: in$, i, l, ex$, fd
' out: ex$, i, er$, er
Sub Compile
  Local x$
  Compile1
  If IsMatch("?") Then
    If fd Then Print #fd, "IF " ex$ " THEN"
    ex$ = ""
    Compile
    x$ = NewTemp$()
    If fd Then Print #fd, x$ " = " ex$
    Match ":"
    ex$ = ""
    If fd Then Print #fd, "ELSE"
    Compile
    If fd Then Print #fd, x$ " = " ex$
    If fd Then Print #fd, "ENDIF"
    ex$ = x$
  EndIf
End Sub

' Compile1 parses expression mid$(in$, i) into ex and written to #fd$, sets er$ and er on error
' in: in$, i, l, ex$, fd
' out: ex$, i, er$, er
Sub Compile1
  Local k, x$
  Compile2
  For k = 0 To 100
    If Not IsMatch("||") Then Exit For
    x$ = NewTemp$()
    If fd Then Print #fd, x$ " = " ex$
    If fd Then Print #fd, "IF NOT " x$ " THEN"
    ex$ = ""
    Compile2
    If fd Then Print #fd, x$ " = " ex$
    ex$ = x$
  Next k
  For k = k To 1 Step -1
    If fd Then Print #fd, "ENDIF"
  Next k
End Sub

' Compile2 parses expression mid$(in$, i) into ex and written to #fd$, sets er$ and er on error
' in: in$, i, l, ex$, fd
' out: ex$, i, er$, er
Sub Compile2
  Local k, x$
  Compile3
  For k = 0 To 100
    If Not IsMatch("&&") Then Exit For
    x$ = NewTemp$()
    If fd Then Print #fd, x$ " = " ex$
    If fd Then Print #fd, "IF " x$ " THEN"
    ex$ = ""
    Compile3
    If fd Then Print #fd, x$ " = " ex$
    ex$ = x$
  Next k
  For k = k To 1 Step -1
    If fd Then Print #fd, "ENDIF"
  Next k
End Sub

' Compile3 parses expression mid$(in$, i) into ex and written to #fd$, sets er$ and er on error
' in: in$, i, l, ex$, fd
' out: ex$, i, er$, er
Sub Compile3
  Local k
  Compile4
  Do
    If Not IsMatch("|") Then Exit Sub
    If IsMatch("|") Then i = i - 2: Exit Sub
    If k = 0 Then ex$ = "(" + ex$ + ")"
    ex$ = ex$ + "OR("
    Compile4
    ex$ = ex$ + ")"
    k = 1
  Loop
End Sub

' Compile4 parses expression mid$(in$, i) into ex$ and written to #fd, sets er$ and er on error
' in: in$, i, l, ex$, fd
' out: ex$, i, er$, er
Sub Compile4
  Local k
  Compile5
  Do
    If Not IsMatch("^") Then Exit Sub
    If k = 0 Then ex$ = "(" + ex$ + ")"
    ex$ = ex$ + "XOR("
    Compile5
    ex$ = ex$ + ")"
    k = 1
  Loop
End Sub

' Compile5 parses expression mid$(in$, i) into ex$ and written to #fd, sets er$ and er on error
' in: in$, i, l, ex$, fd
' out: ex$, i, er$, er
Sub Compile5
  Local k
  Compile6
  Do
    If Not IsMatch("&") Then Exit Sub
    If IsMatch("&") Then i = i - 2: Exit Sub
    If k = 0 Then ex$ = "(" + ex$ + ")"
    ex$ = ex$ + "AND("
    Compile6
    ex$ = ex$ + ")"
    k = 1
  Loop
End Sub

' Compile6 parses expression mid$(in$, i) into ex$ and written to #fd, sets er$ and er on error
' in: in$, i, l, ex$, fd
' out: ex$, i, er$, er
Sub Compile6
  Compile7
  Do
    If IsMatch("==") Then
      ex$ = ex$ + "="
    ElseIf IsMatch("=") Then
      ex$ = ex$ + "="
    ElseIf IsMatch("!=") Then
      ex$ = ex$ + "<>"
    ElseIf IsMatch("<=") Then
      ex$ = ex$ + "<="
    ElseIf IsMatch(">=") Then
      ex$ = ex$ + ">="
    ElseIf IsMatch("<") Then
      If IsMatch("<") Then i = i - 2: Exit Sub
      ex$ = ex$ + "<"
    ElseIf IsMatch(">") Then
      If IsMatch(">") Then i = i - 2: Exit Sub
      ex$ = ex$ + ">"
    Else
      Exit Sub
    EndIf
    Compile7
  Loop
End Sub

' Compile7 parses expression mid$(in$, i) into ex$ and written to #fd, sets er$ and er on error
' in: in$, i, l, ex$, fd
' out: ex$, i, er$, er
Sub Compile7
  Compile8
  Do
    If IsMatch("+") Then
      ex$ = ex$ + "+"
    ElseIf IsMatch("-") Then
      ex$ = ex$ + "-"
    Else
      Exit Sub
    EndIf
    Compile8
  Loop
End Sub

' Compile8 parses expression mid$(in$, i) into ex$ and written to #fd, sets er$ and er on error
' in: in$, i, l, ex$, fd
' out: ex$, i, er$, er
Sub Compile8
  Compile9
  Do
    If IsMatch("*") Then
      ex$ = ex$ + "*"
    ElseIf IsMatch("/") Then
      ex$ = ex$ + "/"
    ElseIf IsMatch("\") Then '"
      ex$ = ex$ + "\" '"
    ElseIf IsMatch("%") Then
      ex$ = ex$ + " MOD "
    Else
      Exit Sub
    EndIf
    Compile9
  Loop
End Sub

' Compile9 parses expression mid$(in$, i) into ex$ and written to #fd, sets er$ and er on error
' in: in$, i, l, ex$, fd
' out: ex$, i, er$, er
Sub Compile9
  Local a$, k, p
  If IsMatch("~") Then
    ex$ = ex$ + "INV("
    Compile9
    ex$ = ex$ + ")"
    Exit Sub
  EndIf
  Do While i <= l
    k = Asc(Mid$(in$, i, 1))
    If k = 45 Then
      ex$ = ex$ + "-"
    ElseIf k = 33 Then
      ex$ = ex$ + "NOT "
    ElseIf k <> 32 And k <> 43 Then
      Exit Do
    EndIf
    i = i + 1
  Loop
  If i > l Then er$ = "operand expected": er = i: Exit Sub
  If k = 40 Then
    a$ = ex$ + "("
    i = i + 1
    ex$ = ""
    Compile
    ex$ = a$ + ex$ + ")"
    Match ")"
  ElseIf k = 38 Or k = 46 Or (k >= 48 And k <= 57) Then
    ex$ = ex$ + ParseNumber$()
  ElseIf (k >= 65 And k <= 90) Or (k >= 97 And k <= 122) Then
    a$ = UCase$(ParseName$())
    If IsMatch(Chr$(40)) Then
      k = Instr(functions$, ":" + a$ + ",")
      If k < 2 Then er$ = "invalid function "+ a$: er = i: Exit Sub
      k = Asc(Mid$(functions$, k - 1, 1)) - 48
      a$ = ex$ + a$ + "("
      ex$ = ""
      Compile
      Do While k > 1
        Match(",")
        a$ = a$ + ex$ + ","
        ex$ = ""
        Compile
        k = k - 1
      Loop
      ex$ = a$ + ex$ + ")"
      Match ")"
    ElseIf a$ = "PI" Then
      ex$ = ex$ + a$
    ElseIf a$ = Left$("TIMER", Len(a$)) Then
      ex$ = ex$ + "TIMER"
    ElseIf a$ = Left$("HIGH", Len(a$)) Then
      ex$ = ex$ + "1"
    ElseIf a$ = Left$("LOW", Len(a$)) Then
      ex$ = ex$ + "0"
    ElseIf a$ = Left$("KEY", Len(a$)) Then
      ex$ = ex$ + "KEY"
    Else
      k = k Or 32
      p = Int(Val(Mid$(a$, 2)))
      If k = 97 Then ' A
        If p < 0 Or p > 5 Then er$ = "invalid pin A" + Str$(p): er = i: Exit Sub
        ex$ = ex$ + "p(" + Str$(p + 35) + ")"
      ElseIf k = 99 Then ' C
        If p < 3 Or p > 22 Then er$ = "invalid pin C" + Str$(p): er = i: Exit Sub
        If p And 1 Then
          ex$ = ex$ + "p(" + Str$(11 - p\2) + ")"
        Else
          ex$ = ex$ + "p(" + Str$(9 + p\2) + ")"
        EndIf
      ElseIf k = 100 Then ' D
        If p < 0 Or p > 13 Then er$ = "invalid pin D" + Str$(p): er = i: Exit Sub
        ex$ = ex$ + "p(" + Str$(p + 21) + ")"
      ElseIf k = 109 Then ' M
        If p < 0 Or p > 9 Then er$ = "invalid memory M" + Str$(p): er = i: Exit Sub
        ex$ = ex$ + "p(" + Str$(p + 41) + ")"
      ElseIf k = 112 Then ' P
        If p < 1 Or p > 40 Then er$ = "invalid pin P" + Str$(p): er = i: Exit Sub
        ex$ = ex$ + "p(" + Str$(p) + ")"
      Else
        er$ = "invalid pin or mem " + a$: er = i
      EndIf
    EndIf
  Else
    er$ = "operand expected": er = i
  EndIf
End Sub

' ParserName$() returns the name at mid$(in$, i)
' advances i to position in in$ after the match
' in: in$, i, l
' out: i
Function ParseName$
  Local j, k
  j = i
  Do
    k = Asc(Mid$(in$, i, 1))
    If k < 48 Or (k > 57 And k < 65) Or (k > 90 And k < 97 And k <> 95) Or k > 122 Then Exit
    i = i + 1
  Loop Until i > l
  ParseName$ = Mid$(in$, j, i - j)
End Function

' ParserNumber$() returns numeric value of mid$(in$, i) as a string
' advances i to position in in$ after the match
' in: in$, i, l
' out: i
Function ParseNumber$
  Local j
  j = i
  If IsOneOf("&") Then
    If IsOneOf("Hh") Then
      Do While IsOneOf("0123456789ABCDEFabcdef"): Loop
      ParseNumber$ = "&h" + Mid$(in$, j + 2, i - j - 2)
    ElseIf IsOneOf("Bb") Then
      Do While IsOneOf("01"): Loop
      ParseNumber$ = "&b" + Mid$(in$, j + 2, i - j - 2)
    Else
      _ = IsOneOf("Oo")
      Do While IsOneOf("01234567"): Loop
      If i - j > 1 Then
        ParseNumber$ = "&o" + Mid$(in$, j, i - j)
      Else
        ParseNumber$ = "0"
      EndIf
    EndIf
  Else
    Do While IsOneOf("0123456789"): Loop
    If IsOneOf(".") Then
      Do While IsOneOf("0123456789"): Loop
    EndIf
    If IsOneOf("Ee") Then
      _ = IsOneOf("+-")
      Do While IsOneOf("0123456789"): Loop
    EndIf
    ParseNumber$ = Mid$(in$, j, i - j)
  EndIf
End Function

' IsOneOf(sel$) returns true if mid$(in$, i, 1) is in sel$
' advances i to position in in$ after the match
' in arg: sel$
' in: in$, i, l
' out: i
Function IsOneOf(sel$)
  If i <= l Then
    IsOneOf = Instr(sel$, Mid$(in$, i, 1))
    If IsOneOf Then i = i + 1
  Else
    IsOneOf = 0
  EndIf
End Function

' IsMatch(tok$) returns true if mid$(in$, i, len(tok$)) = tok$
' trims initial white space, advances i to position in in$ after the match
' in arg: tok$
' in: in$, i, l
' out: i
Function IsMatch(tok$)
  Local m
  m = Len(tok$)
  Do While Mid$(in$, i, 1) = " ": i = i + 1: Loop
  IsMatch = Mid$(in$, i, m) = tok$
  If IsMatch Then i = i + m
End Function

' Match matches tok$ or returns er$ at position er
' trims initial white space, advances i to position in in$ after the match
' in arg: tok$
' in: in$, i, l
' out: i, er$, er
Sub Match(tok$)
  If Not IsMatch(tok$) Then er$ = "'" + tok$ + "' expected": er = i
End Sub

' Trim(str$) strips leading and trailing white space from str$
Sub Trim(str$)
  Local k
  For k = 1 To Len(str$)
    If Asc(Mid$(str$, k, 1)) > 32 Then Exit For
  Next k
  str$ = Mid$(str$, k)
  For k = Len(str$) To 1 Step -1
    If Asc(Mid$(str$, k, 1)) > 32 Then Exit For
  Next k
  str$ = Left$(str$, k)
End Sub

' ClearTemp resets temp.num
' out: temp.num
Sub ClearTemp
  temp.num = 0
End Sub

' NewTemp$() returns a new temporary name X
' in: temp.num
' out: temp.num
Function NewTemp$()
  temp.num = temp.num + 1
  NewTemp$ = "X" + Str$(temp.num)
End Function

' MIN, MAX, SHL, SHR, POW and INV functions

Function MIN(x, y)
  If x < y Then MIN = x Else MIN = y
End Function

Function MAX(x, y)
  If x > y Then MAX = x Else MAX = y
End Function

Function SHL(x, n)
  SHL = x * 2^n
End Function

Function SHR(x, n)
  SHR = x \ 2^n
End Function

Function POW(x, y)
  POW = x ^ y
End Function

Function INV(x)
  INV = -1 - x
End Function

'--------------------------------------------------------------------------------
' BASEDASH.BAS code does not include this part

Sub Init
End Sub

Sub Update
End Sub
